/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"fmt"
)

// FlowOperationUnion - struct for FlowOperationUnion
type FlowOperationUnion struct {
	FlowOperationUnion *FlowOperationUnion
}

// FlowOperationUnionAsFlowOperationUnion is a convenience function that returns FlowOperationUnion wrapped in FlowOperationUnion
func FlowOperationUnionAsFlowOperationUnion(v *FlowOperationUnion) FlowOperationUnion {
	return FlowOperationUnion{
		FlowOperationUnion: v,
	}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *FlowOperationUnion) UnmarshalJSON(data []byte) error {
	var err error
	// this object is nullable so check if the payload is null or empty string
	if string(data) == "" || string(data) == "{}" {
		return nil
	}

	match := 0
	// try to unmarshal data into FlowOperationUnion
	err = newStrictDecoder(data).Decode(&dst.FlowOperationUnion)
	if err == nil {
		jsonFlowOperationUnion, _ := json.Marshal(dst.FlowOperationUnion)
		if string(jsonFlowOperationUnion) == "{}" { // empty struct
			dst.FlowOperationUnion = nil
		} else {
			match++
		}
	} else {
		dst.FlowOperationUnion = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.FlowOperationUnion = nil

		return fmt.Errorf("data matches more than one schema in oneOf(FlowOperationUnion)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(FlowOperationUnion)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src FlowOperationUnion) MarshalJSON() ([]byte, error) {
	if src.FlowOperationUnion != nil {
		return json.Marshal(&src.FlowOperationUnion)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *FlowOperationUnion) GetActualInstance() interface{} {
	if obj == nil {
		return nil
	}
	if obj.FlowOperationUnion != nil {
		return obj.FlowOperationUnion
	}

	// all schemas are nil
	return nil
}

type NullableFlowOperationUnion struct {
	value *FlowOperationUnion
	isSet bool
}

func (v NullableFlowOperationUnion) Get() *FlowOperationUnion {
	return v.value
}

func (v *NullableFlowOperationUnion) Set(val *FlowOperationUnion) {
	v.value = val
	v.isSet = true
}

func (v NullableFlowOperationUnion) IsSet() bool {
	return v.isSet
}

func (v *NullableFlowOperationUnion) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFlowOperationUnion(val *FlowOperationUnion) *NullableFlowOperationUnion {
	return &NullableFlowOperationUnion{value: val, isSet: true}
}

func (v NullableFlowOperationUnion) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFlowOperationUnion) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
